$(function () {
    // otherwise the json file isn't formatted properly - might not be needed on a server
    $.ajaxSetup({'beforeSend': function(xhr){
        if (xhr.overrideMimeType)
            xhr.overrideMimeType("text/plain");
        }
    });

    var lp_search = '';

    // axis_labels = the number on the x co-ordinate to package name mapping
    var axis_labels = [];
    //var packages = [];
    var heat1_data = [];
    var heat2_data = [];
    var heat3_data = [];
    var heat4_data = [];
    var heat5_data = [];
    // used for determining hottest bug's heat
    var heats = [];
    //var datasets = {};
    var updated = '';
    var graph_width = 0;
    // use 1 so we don't get a negative number
    var index = 1;

    var options = {
        points: { show: true,
                  symbol: 'circle',
                  fill: true
                },
        grid: { // borderWidth of 0 removes the border from the whole image - done per mpt
                borderWidth: 0,
                clickable: true,
                hoverable: true },
        xaxis: { ticks: axis_labels,
                 tickLength: 0,
                 show: true,
                 autoscaleMargin: 0.02 },
        yaxis: { autoscaleMargin: 0.02,
                 tickDecimals: 0,
                 position: 'left' },
        legend: { show: false },
        series: { points: { show: true, symbol: 'circle', fill: true }}
    };

    function prepareData(JSONdata) {
        for (var j = 0; j < JSONdata.length; j++) {
            if (JSONdata[j].ran) {
                updated = JSONdata[j].ran;
                JSONdata.pop(j);
            } else {
                heats.push(JSONdata[j].heat1.heat);
            };
        };
        max_heat = (Math.max.apply(Math, heats)/10);
        // a private bug with one subscriber is worth 154 heat points and not
        // interesting
        if (max_heat < 155) {
            max_heat = 155;
        };
        for (var i = 0; i < JSONdata.length; i++) {
            var pkg = JSONdata[i].package;
            // only show packages where its hottest bug is > 1/10 of the heat of
            // the hottest bug
            if (JSONdata[i].heat1.heat > max_heat) {
                // stuff the bug number and title into the data for
                // accessing when clicking and hovering
                if (JSONdata[i].heat1) {
                    heat1_data.push([index, JSONdata[i].heat1.heat,
                        JSONdata[i].heat1.bug, JSONdata[i].heat1.title]);
                };
                if (JSONdata[i].heat2) {
                    heat2_data.push([index, JSONdata[i].heat2.heat,
                        JSONdata[i].heat2.bug, JSONdata[i].heat2.title]);
                };
                if (JSONdata[i].heat3) {
                    heat3_data.push([index, JSONdata[i].heat3.heat,
                        JSONdata[i].heat3.bug, JSONdata[i].heat3.title]);
                };
                if (JSONdata[i].heat4) {
                    heat4_data.push([index, JSONdata[i].heat4.heat,
                        JSONdata[i].heat4.bug, JSONdata[i].heat4.title]);
                };
                if (JSONdata[i].heat5) {
                    heat5_data.push([index, JSONdata[i].heat5.heat,
                        JSONdata[i].heat5.bug, JSONdata[i].heat5.title]);
                };
                // insert a <br> so that the x-axis labels appear stacked and so we
                // can fit more packages in a smaller area
                if (index%2 == 0) {
                    axis_labels.push([index, '<br>' + pkg]);
                }
                else {
                    axis_labels.push([index, pkg]);
                };
                index++;
            };
        };
        graph_width = heat1_data.length * 70;
        // after the data is loaded plot an initial view
        plotAccordingToChoices();
    };

    var datasets = {
        'heat1': {'label': 'heat', 'color': 'darkred', clickable: true,
        points: { show: true, fill: true, fillColor: 'darkred' },
        data: heat1_data},
        'heat2': {'label': 'heat', 'color': 'crimson', clickable: true,
        points: { show: true, fill: true, fillColor: 'crimson' },
        data: heat2_data},
        'heat3': {'label': 'heat', 'color': 'red', clickable: true,
        points: { show: true, fill: true, fillColor: 'red' },
        data: heat3_data},
        'heat4': {'label': 'heat', 'color': 'orange', clickable: true,
        points: { show: true, fill: true, fillColor: 'orange' },
        data: heat4_data},
        'heat5': {'label': 'heat', 'color': 'yellow', clickable: true,
        points: { show: true, fill: true, fillColor: 'yellow' },
        data: heat5_data}
    };

    $.ajax({
        url: datafile,
        dataType: 'json',
        success: prepareData
    });

    $(div_id).bind("plotclick", function (event, pos, item) {
      if (item) {
        //alert("You clicked at " + item.series.data[item.datapoint[0]-1][2]);
        bug_number = item.series.data[item.datapoint[0]-1][2];
        if (item.datapoint) {
            window.location = "http://launchpad.net/bugs/" + bug_number;
        };
      }
    });
    // display the bug title on mouse over
    function showTooltip(x, y, contents) {
        $('<div id="tooltip">' + contents + '</div>').css( {
            position: 'absolute',
            display: 'none',
            top: y + 5,
            left: x + 5,
            border: '1px solid #fdd',
            padding: '2px',
            'background-color': '#fee',
            opacity: 0.80
    }).appendTo("body").fadeIn(200);}
    var previousPoint = null;
    $(div_id).bind("plothover", function (event, pos, item){
        if (item) {
            if (previousPoint != item.dataIndex) {
                // use a pointer to hint its a link
                this.style.cursor = 'pointer';
                previousPoint = item.dataIndex;
                $("#tooltip").remove();
                bug_number = item.series.data[item.datapoint[0]-1][2];
                bug_title = item.series.data[item.datapoint[0]-1][3];
                num_title = bug_number + ': ' + bug_title;
                showTooltip(item.pageX, item.pageY, num_title);
            }
        }
       // remove the tooltip and pointer if there is no item
       else {
         this.style.cursor = 'default';
         $("#tooltip").remove();
         previousPoint = null;
       }
    });

    var heatchoices = $("#heatChoices");
    heatchoices.find("input").click(plotAccordingToChoices);
    function plotAccordingToChoices() {
        $(div_id).height(600);
        if (graph_width > 200) {
            $(div_id).width(graph_width);
        }
        else {
            $(div_id).width(200);
        };
        var data_to_plot = [];
        heatchoices.find("input:checked").each(function() {
            var key = $(this).attr("name");
            if (key) {
                data_to_plot.push(datasets[key]);
            };
        });
        $("p#updated").text('JSON data updated: ' + updated);
        if (data_to_plot.length > 0) {
            $.plot($(div_id), data_to_plot, options);
        };
    };
});
