// otherwise the json file isn't formatted properly - might not be needed on a server
$.ajaxSetup({'beforeSend': function(xhr){
    if (xhr.overrideMimeType)
        xhr.overrideMimeType("text/plain");
    }
});

var lp_search_all_stati = '&field.status:list=NEW&field.status:list=OPINION&field.status:list=INVALID&field.status:list=WONTFIX&field.status:list=CONFIRMED&field.status:list=TRIAGED&field.status:list=INPROGRESS&field.status:list=FIXCOMMITTED&field.status:list=FIXRELEASED&field.status:list=INCOMPLETE_WITH_RESPONSE&field.status:list=INCOMPLETE_WITHOUT_RESPONSE';
var pkg_other = [];
var pkg_crashes = [];
var pkg_apportbug = [];
var pkg_apportlpi = [];
var pkg_apportpackage = [];
var pkg_apportkerneloops = [];
// axis_labels = the number on the y co-ordinate to package name mapping
var axis_labels = [];
var updated = [];
var packages = [];
// use 1 so we don't get a negative number
var index = 1;

$.getJSON(datafile, function(JSONdata) {
    var package_totals = [];
    // create an array of all the package names so they can be ordered
    for (var i = 0; i < JSONdata.length; i++) {
        if (JSONdata[i].ran) {
            updated = JSONdata[i].ran;
            JSONdata.pop(i);
            continue;
        };
        if (JSONdata[i].total < 2) {
            continue;
        };
        var pkg = JSONdata[i].package;
        if (jQuery.inArray(pkg, packages) == -1) {
            packages.push(pkg);
            index++;
        };
        // store the period of the greatest total for making spikes bold
        if (jQuery.inArray(pkg, Object.keys(package_totals)) == -1) {
            package_totals[pkg] = {};
            package_totals[pkg]['total'] = JSONdata[i].total;
            package_totals[pkg]['period'] = JSONdata[i].period;
        }
        else if (jQuery.inArray(pkg, Object.keys(package_totals)) != -1) {
            if (JSONdata[i].total >= package_totals[pkg]['total']) {
                package_totals[pkg]['total'] = JSONdata[i].total;
                package_totals[pkg]['period'] = JSONdata[i].period;
            };
        };
    };
    // sort the packages alphabetically
    packages.sort();
    // then reverse the sort so the packages are in alphabetical descending order
    packages.reverse();
    for (var i = 0; i < JSONdata.length; i++) {
        // the x axis wants an int so use i instead of the package name
        // then stuff the package name in the label
        // 2011-12-22 consider limiting the data so that only the top 20% are initially shown?
        // instead of only packages with more than 2 bugs
        if (JSONdata[i].total >= 2) {
            // For the long period we want index to be a whole number eg 1,2 etc
            // then for the short period one we can have index be the proper
            // one +0.5 to plot it above the existing one
            var pkg = JSONdata[i].package;
            //var pkg_index = 0;
            if (JSONdata[i].period == shortperiod) {
                pkg_index = jQuery.inArray(pkg, packages) + 0.5;
                // plot other since total is a sum of all types
                pkg_other.push([JSONdata[i].other, pkg_index]);
                pkg_crashes.push([JSONdata[i].apportcrash, pkg_index]);
                pkg_apportbug.push([JSONdata[i].apportbug, pkg_index]);
                pkg_apportlpi.push([JSONdata[i].apportlpi, pkg_index]);
                pkg_apportpackage.push([JSONdata[i].apportpackage, pkg_index]);
                pkg_apportkerneloops.push([JSONdata[i].apportkerneloops, pkg_index]);
                var pword = 'this ' + periodword;
                if (package_totals[pkg]['period'] == shortperiod) {
                    var label = createBoldLink(JSONdata[i].package, pword);
                }
                else {
                    var label = createLink(JSONdata[i].package, pword);
                }
                axis_labels.push([pkg_index, label]);
                packages.push(pkg);
                continue;
            };
            if (JSONdata[i].period == longperiod) {
                pkg_index = jQuery.inArray(pkg, packages);
                // plot other since total is a sum of all types
                pkg_other.push([JSONdata[i].other, pkg_index]);
                pkg_crashes.push([JSONdata[i].apportcrash, pkg_index]);
                pkg_apportbug.push([JSONdata[i].apportbug, pkg_index]);
                pkg_apportlpi.push([JSONdata[i].apportlpi, pkg_index]);
                pkg_apportpackage.push([JSONdata[i].apportpackage, pkg_index]);
                pkg_apportkerneloops.push([JSONdata[i].apportkerneloops, pkg_index]);
                var pword = 'last ' + periodword;
                var label = createLink(JSONdata[i].package, pword);
                axis_labels.push([pkg_index, label]);
                packages.push(pkg);
                continue;
            };
        };
    };
    //alert('axis_labels: ' + axis_labels);
    var other_data = {'label': 'other', 'color': 'brown', clickable: true, data: pkg_other};
    var crash_data = {'label': 'apport-crash', 'color': 'red', clickable: true, data: pkg_crashes};
    var bug_data = {'label': 'apport-bug', 'color': 'green', clickable: true, data: pkg_apportbug};
    var lpi_data = {'label': 'apport-lpi', 'color': 'pink', clickable: true, data: pkg_apportlpi};
    var oops_data = {'label': 'apport-kerneloops', 'color': 'black', clickable: true, data: pkg_apportkerneloops};
    var pkg_data = {'label': 'apport-package', 'color': 'blue', clickable: true, data: pkg_apportpackage};
    $(div_id).width(600);
    var graph_height = pkg_other.length * 16;
    if (graph_height > 100) {
        $(div_id).height(graph_height);
    }
    else {
        // use a minimum height in case there are few packages to graph
        $(div_id).height(200);
    }
    var options = {
      bars: { show: true,
              align: 'center',
              horizontal: true,
              // lineWidth of 0 removes borders between bars - done per mpt
              lineWidth: 0,
              // this is a gradient modifying the brightness so the colors do not appear faded and match the legend
              fillColor: { colors: [ { brightness: 1.0 }, { brightness: 1.0 } ] }
            },
      grid: { // borderWidth of 0 removes the border from the whole image - done per mpt
              borderWidth: 0,
              clickable: true,
              hoverable: true },
      // its the y-axis because we want the bars horizontal
      // autoscaleMargin is the fraction of the margin that the scaling algorithm will add to avoid the outermost points ending up on the grid border
      // it needs to be modified because we are using horizontal bars
      yaxis: { ticks: axis_labels,
               // tickLength of 0 removes grid lines which have no meaning here
               tickLength: 0,
               show: true,
               autoscaleMargin: null },
      xaxis: { autoscaleMargin: 0.01,
               // we want the ticks to show whole numbers just like quantity of bugs
               tickDecimals: 0,
               // How can you show it on the top AND the bottom?
               position: top },
      legend: {
          show: true,
          // used to stick the legend outside the graph
          container: $(legend_location)
      },
      series: {
          stack: 0,
          bars: { show: true, barWidth: 0.4 }
      }
    };
    $(div_id).bind("plotclick", function (event, pos, item) {
      if (item) {
        // subtract the 1.5 we added earlier
        var pkg_number = Math.round(item.datapoint[1] - 0.5);
        // using the point clicked look up the package name
        var pkg_name = packages[pkg_number];
        //alert("You clicked at " + pkg_name);
        if (item.series.label != 'other') {
            window.open("http://bugs.launchpad.net/ubuntu/+source/" + pkg_name + "/+bugs?orderby=-id" + lp_search_all_stati + "&field.tag=" + item.series.label, 'new_window');
        };
        // other means bugs without any of the other tags
        if (item.series.label == 'other') {
            window.open("http://bugs.launchpad.net/ubuntu/+source/" + pkg_name + "/+bugs?orderby=-id" + lp_search_all_stati + "&field.tag=" + "-apport-crash+-apport-bug+-apport-lpi+-apport-kerneloops+-apport-package" + "&field.tags_combinator=ALL", 'new_window');
        };
        //window.open("http://bugs.launchpad.net/ubuntu/+source/" + pkg_name + "/+bugs?orderby=-id" + lp_search_all_stati + "&field.tag=" + item.series.label, 'new_window');
      }
    });
    // prepare a hypelink for use in the y axis labels
    function createLink(src_pkg_name, period) {
        // the space after the > is deliberate and allows the pkg_name split using spaces to work
        return '<a href="http://bugs.launchpad.net/ubuntu/+source/' + src_pkg_name + "/+bugs?orderby=-id" + lp_search_all_stati + '" target="_blank"> ' + src_pkg_name + ' (' + period + ')' + '</a>';
    };
    function createBoldLink(src_pkg_name, period) {
        // the space after the > is deliberate and allows the pkg_name split using spaces to work
        return '<b><a href="http://bugs.launchpad.net/ubuntu/+source/' + src_pkg_name + "/+bugs?orderby=-id" + lp_search_all_stati + '" target="_blank"> ' + src_pkg_name + ' (' + period + ')' + '</a></b>';
    };
    // display the number of bugs on mouse over
    function showTooltip(x, y, contents) {
        $('<div id="tooltip">' + contents + '</div>').css( {
            position: 'absolute',
            display: 'none',
            top: y + 5,
            left: x + 5,
            border: '1px solid #fdd',
            padding: '2px',
            'background-color': '#fee',
            opacity: 0.80
    }).appendTo("body").fadeIn(200);}
    var previousPoint = null;
    $(div_id).bind("plothover", function (event, pos, item){
        if (item) {
            if (previousPoint != item.dataIndex) {
                // use a pointer to hint its a link
                this.style.cursor = 'pointer';
                previousPoint = item.dataIndex;
                $("#tooltip").remove();
                // because it's a stacked graph need to subtract
                // start ... item.datapoint[2] from end ... item.datapoint[0]
                var x = item.datapoint[0] - item.datapoint[2],
                    y = item.datapoint[1].toFixed(2);
                showTooltip(item.pageX, item.pageY, x);
            }
        }
       // remove the tooltip and pointer if there is no item
       else {
         this.style.cursor = 'default';
         $("#tooltip").remove();
         previousPoint = null;
       }
    });
    $("p#updated").text('JSON data updated: ' + updated);
    $.plot($(div_id),
        [oops_data, crash_data, pkg_data, bug_data, lpi_data, other_data],
        options);
});
