// otherwise the json file isn't formatted properly - might not be needed on a server
$.ajaxSetup({'beforeSend': function(xhr){
    if (xhr.overrideMimeType)
        xhr.overrideMimeType("text/plain");
    }
});

var bugs = [];
var axis_labels = [];
// used to track bug titles for on hover
var titles = [];
var index = 1;

$.getJSON(datafile, function(JSONdata) {
    for (var i = 0; i < JSONdata.length; i++) {
        if ((JSONdata[i].dupes > 2) && (JSONdata[i].period == period)) {
            var master = JSONdata[i].master;
            bugs.push([JSONdata[i].dupes, index]);
            axis_labels.push([index, master])
            titles.push([index, JSONdata[i].title])
            index++;
        };
    };

    var bugs_data = {'color': 'red', clickable: true, data: bugs};
    $(div_id).width(600);
    var graph_height = bugs.length * 16;
    if (graph_height > 100) {
        $(div_id).height(graph_height);
    }
    else {
        // use a minimum height in case there are few packages to graph
        $(div_id).height(200);
    }
    var options = {
      bars: { show: true,
              align: 'center',
              horizontal: true,
              // lineWidth of 0 removes borders between bars - done per mpt
              lineWidth: 0,
              // this is a gradient modifying the brightness so the colors do not appear faded and match the legend
              //fillColor: { colors: [ { brightness: 1.0 }, { brightness: 1.0 } ] },
              barWidth: 0.4
            },
      grid: { borderWidth: 0,
              clickable: true,
              hoverable: true },
      // its the y-axis because we want the bars horizontal
      // autoscaleMargin is the fraction of the margin that the scaling algorithm will add to avoid the outermost points ending up on the grid border
      // it needs to be modified because we are using horizontal bars
      yaxis: { ticks: axis_labels,
               // tickLength of 0 removes grid lines which have no meaning here
               tickLength: 0,
               show: true,
               autoscaleMargin: null },
      xaxis: { autoscaleMargin: 0.01,
               // we want the ticks to show whole numbers just like quantity of bugs
               tickDecimals: 0,
               // How can you show it on the top AND the bottom?
               position: top },
      legend: {
          show: false,
      }
    };

    $(div_id).bind("plotclick", function (event, pos, item) {
      if (item) {
        //alert("You clicked at " + axis_labels[item.datapoint[1]-1][1]);
        if (item.datapoint) {
            window.location = "http://launchpad.net/bugs/" + axis_labels[item.datapoint[1]-1][1];
        };
      }
    });
    // display the title of the bug on mouse over
    function showTooltip(x, y, contents) {
        $('<div id="tooltip">' + contents + '</div>').css( {
            position: 'absolute',
            display: 'none',
            top: y + 5,
            left: x + 5,
            border: '1px solid #fdd',
            padding: '2px',
            'background-color': '#fee',
            opacity: 0.80
    }).appendTo("body").fadeIn(200);}
    var previousPoint = null;
    $(div_id).bind("plothover", function (event, pos, item){
        if (item) {
            if (previousPoint != item.dataIndex) {
                // use a pointer to hint its a link
                this.style.cursor = 'pointer';
                previousPoint = item.dataIndex;
                $("#tooltip").remove();
                // show the title on mouseover
                var title = titles[item.datapoint[1]-1][1];
                showTooltip(item.pageX, item.pageY, title);
            }
        }
       // remove the tooltip and pointer if there is no item
       else {
         this.style.cursor = 'default';
         $("#tooltip").remove();
         previousPoint = null;
       }
    });
    $.plot($(div_id),
        [bugs_data],
        options);
});
