from lp_utils import *
from os.path import join
import reporting
import logging


def generate_triage_report(ubuntu, bug_supervisor, bug_subscriber,
        directory=None):
    print "Getting new bugtasks."
    if bug_subscriber is not None:
        ubuntu.get_bugtasks(bug_supervisor=bug_supervisor, status=["New"],
            importance=["Unknown", "Critical", "High", "Medium", "Low", "Wishlist"],
            bug_subscriber=bug_subscriber)
    else:
        ubuntu.get_bugtasks(bug_supervisor=bug_supervisor, status=["New"],
            importance=["Unknown", "Critical", "High", "Medium", "Low", "Wishlist"])

    new_bugtasks = set(ubuntu.bugtasks_status["New"])

    ubuntu.get_bugtasks(bug_supervisor=bug_supervisor, status=["New"],
        importance=["Undecided"])
    print "New undecided bugtasks done"
    new_undecided_bugtasks = set([bugtask for bugtask in
        ubuntu.bugtasks_status["New"] if bugtask.importance == "Undecided"])

    ubuntu.get_bugtasks(bug_supervisor=bug_supervisor,
        status=["Incomplete (with response)"]) #, bug_subscriber=bug_subscriber)
    print "New incomplete bugtasks with answers done"

    new_incomplete_with_response_bugtasks = set(
        ubuntu.bugtasks_status["Incomplete (with response)"])

    ubuntu.get_bugtasks(bug_supervisor=bug_supervisor,
        status=["Incomplete (without response)"])
    print "New incomplete bugtasks without answers done"
    new_incomplete_without_response_bugtasks = set(
        ubuntu.bugtasks_status["Incomplete (without response)"])
    other_bugtasks = None

    reporting.write_triage_html_report(bug_supervisor, new_bugtasks,
        new_undecided_bugtasks, new_incomplete_with_response_bugtasks,
        new_incomplete_without_response_bugtasks, other_bugtasks,
        directory)

def generate_last_touched_report(ubuntu, bug_supervisor, directory=None):
    last_touched_bugtasks = ubuntu.get_last_touched_bugtasks(
        bug_supervisor=bug_supervisor)
    reporting.write_last_touched_html_report(last_touched_bugtasks, directory)


def generate_team_report(lp_utils, team_name, reports_directory,
        subscriber_name=None):
    print "Generating report for %s team" % team_name
    team = lp_utils.lp.people[team_name]
    bot = None
    if subscriber_name is not None:
        bot = lp_utils.lp.people[subscriber_name]

    ubuntu = Distro(lp_utils.lp.distributions["ubuntu"])
    generate_triage_report(ubuntu, team, bot, reports_directory)
    generate_last_touched_report(ubuntu, team, reports_directory)



